//*****************************************************************************
// File Name            : helloworld_i2c_eeprom.c
//-----------------------------------------------------------------------------
// Function             : helloworld_i2c_eeprom 
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2016/01/25
//*****************************************************************************
#include <stdio.h>
#include "platform.h"
#include "xparameters.h"
#include "xgpio.h"
#include "xiic.h"
#include "xil_io.h"

#define IIC_BASE_ADDRESS    XPAR_IIC_0_BASEADDR
#define IIC_WR_MASK 0xfe
#define IIC_RD_MASK 0x01
#define IIC_AT24C256B_DEVID 0x50

#define IIC_ADT7410_SADR 0x48

void print(char *str);

int main()
{
int dl;
u8 WriteBuffer[6];
u8 ReadBuffer[4];
init_platform();
u8 sl_adr;
u8 l_adr;
u8 h_adr;

XGpio xgpout;
XGpio_Config xcfg_out;

print("Hello World i2c eeprom\n\r");

xcfg_out.DeviceId = XPAR_AXI_GPIO_0_DEVICE_ID;
XGpio_CfgInitialize(&xgpout, &xcfg_out, XPAR_AXI_GPIO_0_BASEADDR);

  l_adr = 0;
  h_adr = 0;
  //
  sl_adr =IIC_AT24C256B_DEVID ;
  WriteBuffer[0]=h_adr;
  WriteBuffer[1]=l_adr;

  WriteBuffer[2]=0x12;
  WriteBuffer[3]=0x34;
  WriteBuffer[4]=0x56;
  WriteBuffer[5]=0x78;

  /*
  WriteBuffer[2]=0x55;
  WriteBuffer[3]=0x33;
  WriteBuffer[4]=0x0f;
  WriteBuffer[5]=0xf0;
  */
  XIic_Send(IIC_BASE_ADDRESS,sl_adr,WriteBuffer,6,XIIC_STOP);
  xil_printf("wr h_adr=%x l_adr=%x data=%x,%x,%x,%x\n",WriteBuffer[0],WriteBuffer[1],WriteBuffer[2],WriteBuffer[3],WriteBuffer[4],WriteBuffer[5]);
  for(dl=0;dl<1000000;dl++);

  //
  sl_adr =IIC_AT24C256B_DEVID ;
  WriteBuffer[0]=h_adr;
  WriteBuffer[1]=l_adr;
  XIic_Send(IIC_BASE_ADDRESS,sl_adr,WriteBuffer,2,XIIC_REPEATED_START );
  //for(dl=0;dl<1000;dl++);
  sl_adr=IIC_AT24C256B_DEVID ;
  XIic_Recv(IIC_BASE_ADDRESS,sl_adr,ReadBuffer,4,XIIC_STOP );
  for(dl=0;dl<100000;dl++);
  xil_printf("rd dat=%x,%x,%x,%x\n",ReadBuffer[0],ReadBuffer[1],ReadBuffer[2],ReadBuffer[3]);

    cleanup_platform();
    return 0;
}
